BUFFSIZE  equ  0x4000


;static unsigned int emu10k1_calc_pitch_target(unsigned int rate)
proc  calc_pitch_target stdcall, rate:dword
	push	 ebx  edx
	mov	 eax, dword [rate]
	shl	 eax, 8
	xor	 edx, edx
	div	 word 375

	mov	 ebx, eax
	and	 ebx, 1
	shr	 eax, 1
	add	 eax, ebx
	pop	 edx  ebx
	ret
endp


PITCH_48000  equ  0x00004000
PITCH_96000  equ  0x00008000
PITCH_85000  equ  0x00007155
PITCH_80726  equ  0x00006ba2
PITCH_67882  equ  0x00005a82
PITCH_57081  equ  0x00004c1c

;static unsigned int emu10k1_select_interprom(unsigned int pitch_target)
proc  select_interprom stdcall, pitch_target:dword
	mov	 eax, dword [pitch_target]

	cmp	 eax, PITCH_48000
	jne	 @f
	mov	 eax, CCCA_INTERPROM_0
	ret
     @@:
	cmp	 eax, PITCH_48000
	jg	 @f
	mov	 eax, CCCA_INTERPROM_1
	ret
     @@:
	cmp	 eax, PITCH_96000
	jl	 @f
	mov	 eax, CCCA_INTERPROM_0
     @@:
	cmp	 eax, PITCH_85000
	jl	 @f
	mov	 eax, CCCA_INTERPROM_6
	ret
     @@:
	cmp	 eax, PITCH_80726
	jl	 @f
	mov	 eax, CCCA_INTERPROM_5
	ret
     @@:
	cmp	 eax, PITCH_67882
	jl	 @f
	mov	 eax, CCCA_INTERPROM_4
	ret
     @@:
	cmp	 eax, PITCH_57081
	jl	 @f
	mov	 eax, CCCA_INTERPROM_3
	ret
     @@:
	mov	 eax, CCCA_INTERPROM_2
	ret
endp


;; calculate cache invalidate size
;;
;; stereo: channel is stereo
;; w_16: using 16bit samples
;;
;; returns: cache invalidate size in samples
;;
;static inline int emu10k1_ccis(int stereo, int w_16)
proc  emu10k1_ccis stdcall, stereo:dword, w_16:dword
	push	 ebx
	mov	 ebx, 26
	mov	 eax, dword [stereo]
	test	 eax, eax
	jz	 @f
	mov	 ebx, 24
     @@:

	mov	 eax, dword [w_16]
	test	 eax, eax
	jz	 @f
	jmp	 .out:
     @@:
	shl	 ebx, 2
     .out:
	mov	 eax, ebx
	pop	 ebx
	ret
endp



;static void snd_emu10k1_pcm_init_voice(emu10k1_t *emu, int master, int extra, emu10k1_voice_t *evoice,
;                                       unsigned int start_addr, unsigned int end_addr, emu10k1_pcm_mixer_t *mix)
proc  pcm_init_voice stdcall, master:dword, extra:dword, evoice_number:dword, \
				      start_addr:dword, end_addr:dword, mix:dword
	 locals
		send_amount  db 8 dup (0)
		send_routing db 8 dup (0)
		voice	     dd 0
		;silent_page  dd ?
	 endl

	pusha
;        snd_pcm_substream_t *substream = evoice->epcm->substream;
;        snd_pcm_runtime_t *runtime = substream->runtime;
;        unsigned int silent_page, tmp;
;        int voice, stereo, w_16;
;        unsigned char attn, send_amount[8];
;        unsigned char send_routing[8];
;        unsigned long flags;
;        unsigned int pitch_target;
;        unsigned int ccis;

;        voice = evoice->number;
	mov	eax, dword [evoice_number]
	mov	dword [voice], eax
;        stereo = runtime->channels == 2;
;        w_16 = snd_pcm_format_width(runtime->format) == 16;

	mov	eax, dword [start_addr]
	mov	ebx, dword [end_addr]

;        if (!extra && stereo) {
;                start_addr >>= 1;
;                end_addr >>= 1;
;        }
;        if (w_16) {
;                start_addr >>= 1;
;                end_addr >>= 1;
;        }
	mov	edx, dword [extra]
	test	edx, edx
	jz	.0not_extra
	shr	eax, 1
	shr	ebx, 1

	; volume parameters
	mov	byte [send_routing+1], 1
	mov	byte [send_routing+2], 2
	mov	byte [send_routing+3], 3
	jmp	.0end_test_extra
     .0not_extra:
	; mono, left, right (master voice = left)
;FX?                tmp = stereo ? (master ? 1 : 2) : 0;
	mov	ecx, 2
	mov	edx, dword [master]
	test	edx, edx
	jz	.0not_master
	shr	ecx, 1
     .0not_master:
	; volume parameters
;FX?                memcpy(send_routing, &mix->send_routing[tmp][0], 8);
;FX?                memcpy(send_amount, &mix->send_volume[tmp][0], 8);
     .0end_test_extra:
	shr	eax, 1
	shr	ebx, 1

	;ccis = emu10k1_ccis(stereo, w_16);

	;if (master) {
	mov	edx, dword [master]
	test	edx, edx
	jz	.1not_master
		;evoice->epcm->ccca_start_addr = start_addr + ccis;
		;?asm
		;if (extra) {
		mov	edx, dword [extra]
		test	edx, edx
		jz	.1not_extra
			;start_addr += ccis;
			;end_addr += ccis;
		add	eax, ecx
		add	ebx, ecx

			stdcall  snd_emu10k1_ptr_write, CPF, [voice], 0
		jmp	.1end_test_extra
		;}
	     .1not_extra:
		;if (stereo && !extra) {
			mov	 edx, dword [voice]
			stdcall  snd_emu10k1_ptr_write, CPF, edx, CPF_STEREO_MASK
			inc	 edx
			stdcall  snd_emu10k1_ptr_write, CPF, edx, CPF_STEREO_MASK
		;} else {
		;        stdcall  snd_emu10k1_ptr_write, CPF, voice, 0
		;}
	     .1end_test_extra:
	;}
     .1not_master:

	; setup routing
;FX?        cmp      dword [ptr_addr_mask], A_PTR_ADDRESS_MASK ; Audigy ?
;FX?        jne      .not_audigy
;FX?
;FX?        stdcall  snd_emu10k1_ptr_write, A_FXRT1, [voice], \
;FX?                            snd_emu10k1_compose_audigy_fxrt1(send_routing)
;FX?        stdcall  snd_emu10k1_ptr_write, A_FXRT2, [voice], \
;FX?                            snd_emu10k1_compose_audigy_fxrt2(send_routing)
;FX?        stdcall  snd_emu10k1_ptr_write, A_SENDAMOUNTS, [voice], \
;FX?                            ((unsigned int)send_amount[4] << 24) |
;FX?                            ((unsigned int)send_amount[5] << 16) |
;FX?                            ((unsigned int)send_amount[6] << 8) |
;FX?                             (unsigned int)send_amount[7]
;FX?        jmp      .end_test_audigy
;FX?     .not_audigy:
	;stdcall  snd_emu10k1_ptr_write, FXRT, [voice], \
	;                              snd_emu10k1_compose_send_routing(send_routing));
	push	 eax
	snd_emu10k1_compose_send_routing (send_routing)
	stdcall  snd_emu10k1_ptr_write, FXRT, [voice], eax
	pop	 eax
;FX?     .end_test_audigy:
	; Stop CA
	; Assumption that PT is already 0 so no harm overwriting
;FX?        stdcall  snd_emu10k1_ptr_write, PTRX, voice, (send_amount[0] << 8) | send_amount[1]
	mov	 ecx, dword [voice]

	movzx	 edx, byte [send_amount]
	shl	 edx, 8
	or	 dl, byte [send_amount+1]
	stdcall  snd_emu10k1_ptr_write, PTRX, ecx, edx
	movzx	 edx, byte [send_amount+3]
	shl	 edx, 24
	or	 edx, ebx
	stdcall  snd_emu10k1_ptr_write,  DSL, ecx, edx
	movzx	 edx, byte [send_amount+2]
	shl	 edx, 24
	or	 edx, eax
	stdcall  snd_emu10k1_ptr_write, PSST, ecx, edx
	;pitch_target = emu10k1_calc_pitch_target(runtime->rate);

	mov	 edx, dword [extra]
	test	 edx, edx
	jz	 .l1

	;stdcall  snd_emu10k1_ptr_write, CCCA, voice, start_addr | emu10k1_select_interprom(pitch_target) | (w_16 ? 0 : CCCA_8BITSELECT));
	mov	 edx, eax
	or	 edx, CCCA_INTERPROM_0
	stdcall  snd_emu10k1_ptr_write, CCCA, ecx, edx

	jmp	 .l2
    .l1:
	;stdcall  snd_emu10k1_ptr_write, CCCA, voice, (start_addr + ccis) | emu10k1_select_interprom(pitch_target) | (w_16 ? 0 : CCCA_8BITSELECT));
	mov	 edx, eax
	add	 edx, 24 ; +ccis
	or	 edx, CCCA_INTERPROM_0
	stdcall  snd_emu10k1_ptr_write, CCCA, ecx, edx
    .l2:
	; Clear filter delay memory
	mov	 edx, dword [voice]
	stdcall  snd_emu10k1_ptr_write, Z1, edx, 0
	stdcall  snd_emu10k1_ptr_write, Z2, edx, 0
	; invalidate maps
	;silent_page = ((unsigned int)emu->silent_page.addr << 1) | MAP_PTI_MASK;
	mov	 eax, [ctrl.buffer]
	call	 GetPgAddr
	shl	 eax, 1
	or	 eax, MAP_PTI_MASK
	stdcall  snd_emu10k1_ptr_write, MAPA, edx, eax ;dword [silent_page]
	stdcall  snd_emu10k1_ptr_write, MAPB, edx, eax ;dword [silent_page]
	; modulation envelope
	stdcall  snd_emu10k1_ptr_write, CVCF, edx, 0xFFFF
	stdcall  snd_emu10k1_ptr_write, VTFT, edx, 0xFFFF
	stdcall  snd_emu10k1_ptr_write, ATKHLDM, edx, 0
	stdcall  snd_emu10k1_ptr_write, DCYSUSM, edx, 0x007F
	stdcall  snd_emu10k1_ptr_write, LFOVAL1, edx, 0x8000
	stdcall  snd_emu10k1_ptr_write, LFOVAL2, edx, 0x8000
	stdcall  snd_emu10k1_ptr_write, FMMOD, edx, 0
	stdcall  snd_emu10k1_ptr_write, TREMFRQ, edx, 0
	stdcall  snd_emu10k1_ptr_write, FM2FRQ2, edx, 0
	stdcall  snd_emu10k1_ptr_write, ENVVAL, edx, 0x8000
	; volume envelope
	stdcall  snd_emu10k1_ptr_write, ATKHLDV, edx, 0x7F7F
	stdcall  snd_emu10k1_ptr_write, ENVVOL, edx, 0x0000
	; filter envelope
	stdcall  snd_emu10k1_ptr_write, PEFE_FILTERAMOUNT, edx, 0x7F
	; pitch envelope
	stdcall  snd_emu10k1_ptr_write, PEFE_PITCHAMOUNT, edx, 0

	popa
	ret
endp

proc  playback_prepare stdcall;(snd_pcm_substream_t * substream)
;        emu10k1_t *emu = snd_pcm_substream_chip(substream);
;        snd_pcm_runtime_t *runtime = substream->runtime;
;        emu10k1_pcm_t *epcm = runtime->private_data;
;        unsigned int start_addr, end_addr;

	push	 eax ebx
    if FDEBUG
	mov   esi, msgPlaybackPrepare
	call  SysMsgBoardStr
    end if

	;start_addr = epcm->start_addr;                         ; [ctrl.buffer]
	;end_addr = snd_pcm_lib_period_bytes(substream);        ; [ctrl.buffer]+0x4000
	mov	 eax, [ctrl.buffer]
	;-?call     GetPgAddr
	mov	 ebx, 0x4000

	;if (runtime->channels == 2) {
	;        start_addr >>= 1;
	;        end_addr >>= 1;
	;}
	shr	 eax, 1
	shr	 ebx, 1

	;end_addr += start_addr;
	add	 ebx, eax
	stdcall  pcm_init_voice, 1, 1, 0, eax, ebx, 0 ;stdcall  pcm_init_voice, 1, 1, epcm->extra, start_addr, end_addr, 0
	;start_addr = epcm->start_addr;
	;end_addr = epcm->start_addr + snd_pcm_lib_buffer_bytes(substream);
	mov	 eax, [ctrl.buffer]
	;-?call     GetPgAddr
	mov	 ebx, 0x4000
	add	 ebx, eax
	stdcall  pcm_init_voice, 1, 0, 0, eax, ebx, 0 ;stdcall  pcm_init_voice, 1, 0, epcm->voices[0], start_addr, end_addr, &emu->pcm_mixer[substream->number]);
	;if (epcm->voices[1])
	;        stdcall  pcm_init_voice, 0, 0, epcm->voices[1], \
	;                                   start_addr, end_addr, &emu->pcm_mixer[substream->number]);
	;?asm

    if FDEBUG
	mov   esi, msgDone
	call  SysMsgBoardStr
    end if
	pop	 ebx eax
	ret
endp

proc  playback_invalidate_cache stdcall, extra:dword, evoice_number:dword
	locals
	     stereo  db ?
	     voice   dd 0
	endl
;        snd_pcm_runtime_t *runtime;
;        unsigned int voice, stereo, i, ccis, cra = 64, cs, sample;

;        if (evoice == NULL)
;                return;
;        runtime = evoice->epcm->substream->runtime;
;        voice = evoice->number;

	push	 eax ebx ecx edx
	;stereo = (!extra && runtime->channels == 2);
	xor	 ax, ax
	mov	 edx, dword [extra]
	test	 edx, edx
	jz	 @f
	inc	 ax
    @@:
	mov	 byte [stereo], al
	;sample = snd_pcm_format_width(runtime->format) == 16 ? 0 : 0x80808080;
	;ccis = emu10k1_ccis(stereo, sample == 0);
	; set cs to 2 * number of cache registers beside the invalidated
	;cs = (sample == 0) ? (32-ccis) : (64-ccis+1) >> 1;
	mov	 eax, 32-24
	mov	 ecx, CD0
	add	 eax, ecx
	mov	 ebx, dword [evoice_number]
	mov	 edx, ebx
	inc	 edx
	;if (cs > 16) cs = 16;
	;for (i = 0; i < cs; i++) {
    .c1:
		;stdcall  snd_emu10k1_ptr_write, CD0 + i, voice, sample
		stdcall  snd_emu10k1_ptr_write, ecx, ebx, 0
		;if (stereo) {
		cmp	byte [stereo], 0
		jz	@f
			;stdcall  snd_emu10k1_ptr_write, CD0 + i, voice + 1, sample
			stdcall  snd_emu10k1_ptr_write, ecx, edx, 0
	     @@:
		;}
	;}
	inc	ecx
	cmp	ecx, eax
	jl	.c1
	; reset cache
	stdcall  snd_emu10k1_ptr_write, CCR_CACHEINVALIDSIZE, ebx, 0
	stdcall  snd_emu10k1_ptr_write, CCR_READADDRESS, ebx, 64 ;cra
	;if (stereo) {
	cmp	byte [stereo], 0
	jz	@f
		stdcall  snd_emu10k1_ptr_write, CCR_CACHEINVALIDSIZE, edx, 0
		stdcall  snd_emu10k1_ptr_write, CCR_READADDRESS, edx, 64 ;cra
	;}
     @@:
	; fill cache
	stdcall  snd_emu10k1_ptr_write, CCR_CACHEINVALIDSIZE, dword [evoice_number], 24 ;ccis
	;if (stereo) {
	cmp	byte [stereo], 0
	jz	@f
		stdcall  snd_emu10k1_ptr_write, CCR_CACHEINVALIDSIZE, edx, 24 ;ccis
	;}
     @@:
	pop	 edx ecx ebx eax
	ret
endp

proc  playback_prepare_voice stdcall, evoice_number:dword, master:dword, extra:dword;, mix:dword
;        snd_pcm_substream_t *substream;
;        snd_pcm_runtime_t *runtime;
;        unsigned int attn, vattn;
;        unsigned int voice, tmp;
	;-locals
	;-     vattn   dd 0xffff0000
	;-endl

;        if (evoice == NULL)     ; skip second voice for mono
;                return;
;        substream = evoice->epcm->substream;
;        runtime = substream->runtime;
;        voice = evoice->number;

	push	 eax ebx edx
	;attn = extra ? 0 : 0x00FF;
	xor	 eax, eax
	mov	 edx, dword [extra]
	test	 edx, edx
	jz	 @f
	mov	 eax, 0x00FF
     @@:
	;tmp = runtime->channels == 2 ? (master ? 1 : 2) : 0;
	xor	 ebx, ebx
	inc	 ebx
	mov	 edx, dword [master]
	test	 edx, edx
	jz	 @f
	inc	 ebx
     @@:
	;vattn = mix != NULL ? (mix->attn[tmp] << 16) : 0;
	;?asm

	;-mov      ebx, dword [vattn]
	;-or       ebx, 0xFFFF
	mov	 edx, dword [evoice_number]
	stdcall  snd_emu10k1_ptr_write, IFATN, edx, eax ;attn
	stdcall  snd_emu10k1_ptr_write, VTFT, edx, 0xFFFFFFFF ;-ebx ;vattn | 0xFFFF
	stdcall  snd_emu10k1_ptr_write, CVCF, edx, 0xFFFFFFFF ;-ebx ;vattn | 0xFFFF
	stdcall  snd_emu10k1_ptr_write, DCYSUSV, edx, 0x7F7F
	stdcall  snd_emu10k1_voice_clear_loop_stop, edx
	pop	 edx ebx eax
	ret
endp

proc  playback_trigger_voice stdcall, evoice_number:dword, master:dword, extra:dword
;        snd_pcm_substream_t *substream;
;        snd_pcm_runtime_t *runtime;
;        unsigned int voice, pitch, pitch_target;
	 locals
	      voice  dd 0
	 endl

	push	eax ebx edx
;        if (evoice == NULL)     ; skip second voice for mono
;                return;
;        substream = evoice->epcm->substream;
;        runtime = substream->runtime;
;        voice = evoice->number;

	;pitch = snd_emu10k1_rate_to_pitch(runtime->rate) >> 8;
	stdcall snd_emu10k1_rate_to_pitch, 48000
	shr	eax, 8
	mov	ebx, eax
	;pitch_target = emu10k1_calc_pitch_target(runtime->rate);
	mov	eax, dword [evoice_number]
	stdcall snd_emu10k1_ptr_write, PTRX_PITCHTARGET, eax, PITCH_48000 ;pitch_target
	;if (master || evoice->epcm->type == PLAYBACK_EFX)
	mov	edx, dword [master]
	test	edx, edx
	jz	@f
	stdcall  snd_emu10k1_ptr_write, CPF_CURRENTPITCH, eax, PITCH_48000 ;pitch_target
     @@:
	stdcall  snd_emu10k1_ptr_write, IP, dword [evoice_number], ebx ;pitch
	;if (extra)
	mov	edx, dword [extra]
	test	edx, edx
	jz	@f
	stdcall snd_emu10k1_voice_intr_enable, eax
     @@:
	pop	edx ebx eax
	ret
endp

proc  playback_stop_voice stdcall, evoice_number:dword
;        unsigned int voice;

;        if (evoice == NULL)
;                return;
	mov	 eax, dword [evoice_number]
      ;  test     eax, eax
      ;  jnz      @f
      ;  ret
     ;@@:
;        voice = evoice->number;
	stdcall  snd_emu10k1_voice_intr_disable, eax ;voice
	stdcall  snd_emu10k1_ptr_write, PTRX_PITCHTARGET, eax, 0
	stdcall  snd_emu10k1_ptr_write, CPF_CURRENTPITCH, eax, 0
	stdcall  snd_emu10k1_ptr_write, IFATN, eax, 0xFFFF
	stdcall  snd_emu10k1_ptr_write, VTFT, eax, 0xFFFF
	stdcall  snd_emu10k1_ptr_write, CVCF, eax, 0xFFFF
	stdcall  snd_emu10k1_ptr_write, IP, eax, 0
	ret
endp

proc  playback_trigger stdcall, cmd:dword   ;-substream:dword, cmd:dword
	mov	eax, dword [cmd]
	;switch (cmd) {
	;case SNDRV_PCM_TRIGGER_START:
	cmp	eax, DEV_PLAY ;-SNDRV_PCM_TRIGGER_START
	jne	@f
		;?stdcall  playback_invalidate_cache, 1, epcm->extra     ; do we need this?
		stdcall  playback_invalidate_cache, 0, 0;epcm->voices[0]
		; follow thru
	;mov     eax, SNDRV_PCM_TRIGGER_PAUSE_RELEASE
     @@:
	;case SNDRV_PCM_TRIGGER_PAUSE_RELEASE:
	;?cmp     eax, SNDRV_PCM_TRIGGER_PAUSE_RELEASE
	;?jne     @f
		;-mix = &emu->pcm_mixer[substream->number];
		stdcall  playback_prepare_voice, 0, 1, 0 ;epcm->voices[0], 1, 0;, mix
		stdcall  playback_prepare_voice, 1, 0, 0 ;epcm->voices[1], 0, 0;, mix
		;?stdcall  playback_prepare_voice, epcm->extra, 1, 1;, 0
		stdcall  playback_trigger_voice, 0, 1, 0 ;epcm->voices[0], 1, 0
		stdcall  playback_trigger_voice, 1, 0, 0 ;epcm->voices[1], 0, 0
		;?stdcall  playback_trigger_voice, epcm->extra, 1, 1
	jmp	.end_trigger
     @@:
	;case SNDRV_PCM_TRIGGER_STOP:
	;case SNDRV_PCM_TRIGGER_PAUSE_PUSH:
	cmp	eax, DEV_STOP ;-SNDRV_PCM_TRIGGER_STOP or SNDRV_PCM_TRIGGER_PAUSE_PUSH
	jne	@f
		stdcall  playback_stop_voice, 0 ;epcm->voices[0]
		stdcall  playback_stop_voice, 1 ;epcm->voices[1]
		;?stdcall  playback_stop_voice, epcm->extra
	jmp	.end_trigger
     @@:
	;default:
		;result = -EINVAL;
		mov	eax, -5
		ret
     .end_trigger:
	xor	eax, eax
	ret
endp


proc  playback_pointer stdcall, substream:dword
;        emu10k1_t *emu = snd_pcm_substream_chip(substream);
;        snd_pcm_runtime_t *runtime = substream->runtime;
;        emu10k1_pcm_t *epcm = runtime->private_data;
;        unsigned int ptr;

;        if (!epcm->running)
;                return 0;
	;ptr = stdcall  snd_emu10k1_ptr_read(emu, CCCA, epcm->voices[0]->number) & 0x00ffffff;
	stdcall  snd_emu10k1_ptr_read, CCCA, 0 ;epcm->voices[0]->number
	and	 eax, 0x00FFFFFF
if 0   ;; Perex's code ;;
	;ptr += runtime->buffer_size;
	;ptr -= epcm->ccca_start_addr;
	;ptr %= runtime->buffer_size;
	add	 eax, BUFFSIZE
	sub	 eax, dword [ccca_start_addr]
	 %	 ebx, BUFFSIZE

else   ;; EMU10K1 Open Source code from Creative ;;
	;if (ptr < epcm->ccca_start_addr)
	mov	 ebx, dword [ccca_start_addr]
	cmp	 eax, ebx
	jge	 .l1
		;ptr += runtime->buffer_size - epcm->ccca_start_addr;
	add	 eax, BUFFSIZE
	sub	 eax, ebx
	jmp	 .l2
    .l1:
	;else {
		;ptr -= epcm->ccca_start_addr;
	sub	 eax, ebx
		;if (ptr >= runtime->buffer_size)
		;        ptr -= runtime->buffer_size;
	cmp	 eax, BUFFSIZE
	jl	 @f
	sub	 eax, BUFFSIZE
    @@:
	;}
    .l2:
end if
	;return ptr;
	ret
endp


;________From emumixer.c____________________________
proc  emu10k1_mixer stdcall
;...;
	test	 [ctrl.chip_type], AUDIGY_CHIP ; Audigy ?   ;cmp      dword [ptr_addr_mask], A_PTR_ADDRESS_MASK ; Audigy ?
	jne	 .not_audigy
	; set master volume to 0 dB
	stdcall  snd_emu10k1_ac97_write, CODEC_MASTER_VOL_REG, 0  ;AC97_MASTER, 0x0000
	; set capture source to mic
	stdcall  snd_emu10k1_ac97_write, CODEC_REC_SEL, 0 ;AC97_REC_SEL, 0x0000
	jmp	 .end_audigy_test
   .not_audigy:
	; Credits for cards based on STAC9758:
	;   James Courtier-Dutton <James@superbug.demon.co.uk>
	;   Voluspa <voluspa@comhem.se>
	cmp	 [codec.chip_id], CHIP_SIGMATEL or 0x58
	jne	 @f
	stdcall  snd_emu10k1_ptr_write, AC97SLOT, 0, AC97SLOT_CNTR or AC97SLOT_LFE or AC97SLOT_REAR_LEFT or AC97SLOT_REAR_RIGHT
    @@:
	; remove unused AC97 controls
	stdcall  snd_emu10k1_ac97_write, CODEC_SURROUND_MASTER, 0x0202 ;AC97_SURROUND_MASTER, 0x0202
	stdcall  snd_emu10k1_ac97_write, CODEC_CENTER_LFE_MASTER, 0x0202 ;AC97_CENTER_LFE_MASTER, 0x0202
   .end_audigy_test:
;...;
	ret
endp


;______________________________
ccca_start_addr  dd ?
