;;  Routines for control of EMU10K1 chips


;unsigned int snd_emu10k1_ptr_read(struct snd_emu10k1 * emu, unsigned int reg, unsigned int chn)
proc  snd_emu10k1_ptr_read stdcall, reg:dword, chn:dword
;        unsigned int regptr, val;
;        unsigned int mask;

	push   ebx ecx edx
	;mask = emu->audigy ? A_PTR_ADDRESS_MASK : PTR_ADDRESS_MASK;
	test   [ctrl.chip_type], AUDIGY_CHIP
	jz     @f
	mov    edx, A_PTR_ADDRESS_MASK
	jmp    @f
  .not_audigy:
	mov    edx, PTR_ADDRESS_MASK
  @@:
	;regptr = ((reg << 16) & mask) | (chn & PTR_CHANNELNUM_MASK);
	mov    eax, [reg]
	mov    ecx, eax
	shl    eax, 16
	and    eax, edx
	mov    ebx, [chn]
	and    ebx, PTR_CHANNELNUM_MASK
	or     eax, edx

	;if (reg & 0xff000000) {
	test   ecx, 0xFF000000
	jz     @f
;                unsigned char size, offset;
		
		;size = (reg >> 24) & 0x3f;
		;offset = (reg >> 16) & 0x1f;
		;mask = ((1 << size) - 1) << offset;
		mov	ebx, ecx
		shr	ecx, 24
		and	ecx, 0x3F
		shr	ebx, 16
		and	ebx, 0x1F
		xor	edx, edx
		inc	edx
		shl	edx, cl ;ecx
		dec	edx
				       ;-shl     edx, ebx
		mov	cl, bl
		shl	edx, cl

		;outl(regptr, emu->port + PTR);
		;val = inl(emu->port + DATA);
		push	edx
		mov	edx, PTR
		call	[ctrl.ctrl_write32]
		mov	edx, DATA
		call	[ctrl.ctrl_read32]
		pop	edx

		;return (val & mask) >> offset;
		and	eax, edx
				       ;-shr     eax, ebx
		mov	cl, bl
		shr	eax, cl
		jmp	.out
	;} else {
  @@:
		;outl(regptr, emu->port + PTR);
		;val = inl(emu->port + DATA);
		;return val;
		mov	edx, PTR
		call	[ctrl.ctrl_write32]
		mov	edx, DATA
		call	[ctrl.ctrl_read32]
	;}
  .out:
		pop	edx ecx ebx
		ret
endp

;void snd_emu10k1_ptr_write(struct snd_emu10k1 *emu, unsigned int reg, unsigned int chn, unsigned int data)
proc  snd_emu10k1_ptr_write  stdcall, reg:dword, chn:dword, data:dword
;        unsigned int regptr;
;        unsigned int mask;

;        if (!emu) {
;                snd_printk(KERN_ERR "ptr_write: emu is null!\n");
;                dump_stack();
;                return;
;        }

	push	eax ebx ecx edx
	;mask = emu->audigy ? A_PTR_ADDRESS_MASK : PTR_ADDRESS_MASK;
	mov	edx, PTR_ADDRESS_MASK
	test	[ctrl.chip_type], AUDIGY_CHIP
	jz	@f
	mov	edx, A_PTR_ADDRESS_MASK
  @@:
	;regptr = ((reg << 16) & mask) | (chn & PTR_CHANNELNUM_MASK);
	mov	eax, [reg]
	mov	ecx, eax
	shl	eax, 16
	and	eax, edx
	mov	ebx, [chn]
	and	ebx, PTR_CHANNELNUM_MASK
	or	eax, ebx

	;if (reg & 0xff000000) {
	test	ecx, 0xFF000000
	jz	@f
;                unsigned char size, offset;
		
		;size = (reg >> 24) & 0x3f;
		;offset = (reg >> 16) & 0x1f;
		;mask = ((1 << size) - 1) << offset;
		mov	ebx, ecx
		shr	ecx, 24
		and	ecx, 0x3F
		shr	ebx, 16
		and	ebx, 0x1F
		xor	edx, edx
		inc	edx
		shl	edx, cl ;ecx
		dec	edx

		mov	ecx, ebx
		shl	edx, cl
		;data = (data << offset) & mask;
		mov	ebx, [data]
		shl	ebx, cl
		and	ebx, edx

		;outl(regptr, emu->port + PTR);
		;data |= inl(emu->port + DATA) & ~mask;
		;outl(data, emu->port + DATA);
		push	edx
		mov	edx, PTR
		call	[ctrl.ctrl_write32]
		mov	edx, DATA
		call	[ctrl.ctrl_read32]
		pop	edx
		xor	edx, -1
		and	eax, edx
		or	eax, ebx
		mov	edx, DATA
		call	[ctrl.ctrl_write32]
		jmp	.out
	;} else {
  @@:
		;outl(regptr, emu->port + PTR);
		;outl(data, emu->port + DATA);
		mov	edx, PTR
		call	[ctrl.ctrl_write32]
		mov	edx, DATA
		mov	eax, [data]
		call	[ctrl.ctrl_write32]
	;}
  .out:
		pop	edx ecx ebx eax
		ret
endp


;unsigned int snd_emu10k1_ptr20_read(struct snd_emu10k1 * emu, unsigned int reg, unsigned int chn)
proc  snd_emu10k1_ptr20_read  stdcall, reg:dword, chn:dword
;        unsigned int regptr, val;
  
	push	edx
	;regptr = (reg << 16) | chn;
	mov	eax, [reg]
	shl	eax, 16
	or	eax, [chn]

	;outl(regptr, emu->port + 0x20 + PTR);
	;val = inl(emu->port + 0x20 + DATA);
	;return val;
	mov	edx, PTR + 0x20
	call	[ctrl.ctrl_write32]
	mov	edx, DATA + 0x20
	call	[ctrl.ctrl_read32]
	pop	edx
	ret
endp

;void snd_emu10k1_ptr20_write(struct snd_emu10k1 *emu, unsigned int reg, unsigned int chn, unsigned int data)
proc  snd_emu10k1_ptr20_write  stdcall, reg:dword, chn:dword, data:dword
;        unsigned int regptr;

	push	eax edx
	;regptr = (reg << 16) | chn;
	mov	eax, [reg]
	shl	eax, 16
	or	eax, [chn]

	;outl(regptr, emu->port + 0x20 + PTR);
	;outl(data, emu->port + 0x20 + DATA);
	mov	edx, PTR + 0x20
	call	[ctrl.ctrl_write32]
	mov	edx, DATA + 0x20
	mov	eax, [data]
	call	[ctrl.ctrl_write32]
	pop	edx eax
	ret
endp

;int snd_emu10k1_spi_write(struct snd_emu10k1 * emu, unsigned int data)
proc  snd_emu10k1_spi_write  stdcall, data:dword
;        unsigned int reset, set;
;        unsigned int reg, tmp;
;        int n, result;
;        int err = 0;

	push	ebx ecx edx edi
	;; This function is not re-entrant, so protect against it.
	;spin_lock(&emu->spi_lock);
	;if (emu->card_capabilities->ca0108_chip)
	test	[ctrl.chip_type], CA0108_CHIP
;        jz      .not_ca0108
	jz	.spi_write_exit
		;reg = 0x3c; ;; PTR20, reg 0x3c
		mov	ebx, 0x3C
;                jmp     @f
	;else {
;  .not_ca0108:
		;; For other chip types the SPI register is currently unknown.
		;err = 1;
;                jmp     .spi_write_exit  ;goto spi_write_exit;
	;}
;  @@:
	mov	edx, [data]
	;if (data > 0xffff) {
	cmp	edx, 0xFFFF
	jng	@f
		;; Only 16bit values allowed
		;err = 1;
		jmp	.spi_write_exit  ;goto spi_write_exit;
	;}
  @@:

	;tmp = snd_emu10k1_ptr20_read(emu, reg, 0);
	stdcall snd_emu10k1_ptr20_read, ebx, 0
	;reset = (tmp & ~0x3ffff) | 0x20000; ;; Set xxx20000
	;set = reset | 0x10000; ;; Set xxx1xxxx
	and	eax, 0xFFFC0000
	or	eax, 0x20000
	mov	edx, 0x10000
	or	edx, eax
	;snd_emu10k1_ptr20_write(emu, reg, 0, reset | data);
	mov	edi, [data]
	or	edi, eax
	stdcall snd_emu10k1_ptr20_write, ebx, 0, edi
	;tmp = snd_emu10k1_ptr20_read(emu, reg, 0); ;; write post
	stdcall snd_emu10k1_ptr20_read, ebx, 0
	;snd_emu10k1_ptr20_write(emu, reg, 0, set | data);
	push	edi
	mov	edi, [data]
	or	edi, edx
	stdcall snd_emu10k1_ptr20_write, ebx, 0, edi
	pop	edi
	;result = 1;
	;; Wait for status bit to return to 0
	;for (n = 0; n < 100; n++) {
	mov	ecx, 10 ; udelay time
	mov	edx, 100
  .again:
		;udelay(10);
		;tmp = snd_emu10k1_ptr20_read(emu, reg, 0);
		call  udelay
		stdcall snd_emu10k1_ptr20_read, ebx, 0

		;if (!(tmp & 0x10000)) {
		test  eax, 0x10000
		jz    .ok
			;result = 0;
			;break;
		;}

		dec   edx
		jnz   .again
	;}
	;if (result) {
		;; Timed out
		;err = 1;
		jmp	.spi_write_exit  ;goto spi_write_exit;
	;}
  .ok:
	;snd_emu10k1_ptr20_write(emu, reg, 0, reset | data);
	;tmp = snd_emu10k1_ptr20_read(emu, reg, 0); ;; Write post
	stdcall snd_emu10k1_ptr20_write, ebx, 0, edi
	stdcall snd_emu10k1_ptr20_read, ebx, 0
	;err = 0;
	pop	edi edx ecx ebx
	xor	eax, eax
	ret
  .spi_write_exit:
	;spin_unlock(&emu->spi_lock);
	;return err;
	pop	edi edx ecx ebx
	xor	eax, eax
	inc	eax
	ret
endp


;; The ADC does not support i2c read, so only write is implemented ;;
;int snd_emu10k1_i2c_write(struct snd_emu10k1 *emu, u32 reg, u32 value)
proc  snd_emu10k1_i2c_write  stdcall, reg:dword, value:dword
;        u32 tmp;
;        int timeout = 0;
;        int status;
;        int retry;
;        int err = 0;

	push	ebx
	;if ((reg > 0x7f) || (value > 0x1ff)) {
	;        snd_printk(KERN_ERR "i2c_write: invalid values.\n");
	;        return -EINVAL;
	;}
	mov	ebx, [reg]
	mov	eax, [value]
	cmp	ebx, 0x7F
	jg	.err1
	cmp	eax, 0x1FF
	jng	@f
  .err1:
      if FDEBUG
	push	esi
	mov	esi, emsgI2C_InvalidValues
	call	SysMsgBoardStr
	pop	esi
      end if
	pop	ebx
	mov	eax, -1
	ret
  @@:

	;; This function is not re-entrant, so protect against it. ;;
	;spin_lock(&emu->i2c_lock);

	;tmp = reg << 25 | value << 16;
	shl	eax, 16
	shl	ebx, 25
	or	ebx, eax

	;; This controls the I2C connected to the WM8775 ADC Codec ;;
	;snd_emu10k1_ptr20_write(emu, P17V_I2C_1, 0, tmp);
	;tmp = snd_emu10k1_ptr20_read(emu, P17V_I2C_1, 0); ;; write post ;;
	stdcall snd_emu10k1_ptr20_write, P17V_I2C_1, 0, ebx
	stdcall snd_emu10k1_ptr20_read, P17V_I2C_1, 0 ;; write post ;;

	xor	ebx, ebx
	;for (retry = 0; retry < 10; retry++) {
	push	ecx
	mov	ecx, 10
  .retry_transaction:
		;; Send the data to i2c ;;
		;tmp = 0;
		;tmp = tmp | (I2C_A_ADC_LAST|I2C_A_ADC_START|I2C_A_ADC_ADD);
		;snd_emu10k1_ptr20_write(emu, P17V_I2C_ADDR, 0, tmp);
		stdcall snd_emu10k1_ptr20_write, P17V_I2C_ADDR, 0, (I2C_A_ADC_LAST or I2C_A_ADC_START or I2C_A_ADC_ADD)

		;; Wait till the transaction ends ;;
		;while (1) {
  .wait:
			;mdelay(1);
			mov	eax, 1000
			call	StallExec
			;status = snd_emu10k1_ptr20_read(emu, P17V_I2C_ADDR, 0);
			stdcall snd_emu10k1_ptr20_read, P17V_I2C_ADDR, 0
			inc	ebx ;timeout++;
			;if ((status & I2C_A_ADC_START) == 0)  break;
			test	eax, I2C_A_ADC_START
			jz	.end_wait

			;if (timeout > 1000) {
			cmp	ebx, 1000
			jng	@f
				;snd_printk(KERN_WARNING "emu10k1:I2C:timeout status=0x%x\n", status);
				;break;
			      if  FDEBUG
				push	  esi
				mov	  esi, msgI2C_TimeoutStatus
				call	  SysMsgBoardStr
				call	  dword2str
				call	  SysMsgBoardStr
				pop	  esi
			      end if
				jmp	  .end_wait
			;}
  @@:
			jmp	.wait
		;}
  .end_wait:
		;;Read back and see if the transaction is successful
		;if ((status & I2C_A_ADC_ABORT) == 0) break;
		test	eax, I2C_A_ADC_ABORT
		jz	.ok

		dec	ecx
		jnz	.retry_transaction
	;}

	;if (retry == 10) {
		;snd_printk(KERN_ERR "Writing to ADC failed!\n");
		;snd_printk(KERN_ERR "status=0x%x, reg=%d, value=%d\n", status, reg, value);
		;; dump_stack();
		;err = -EINVAL;
	      if  FDEBUG
		push	  esi
		mov	  esi, emsgWritingToADCFailed
		call	  SysMsgBoardStr

		mov	  esi, aStatus
		call	  SysMsgBoardStr
		call	  dword2str
		call	  SysMsgBoardStr

		mov	  esi, aReg
		call	  SysMsgBoardStr
		mov	  eax, [reg]
		call	  dword2str
		call	  SysMsgBoardStr

		mov	  esi, aValue
		call	  SysMsgBoardStr
		mov	  eax, [value]
		call	  dword2str
		call	  SysMsgBoardStr
		pop	  esi
	      end if
		pop	  ecx ebx
		mov	  eax, -1
		ret
	;}
  .ok:
	;spin_unlock(&emu->i2c_lock);
	;return err;
	pop	ecx ebx
	xor	eax, eax
	ret
endp


;int snd_emu1010_fpga_write(struct snd_emu10k1 * emu, u32 reg, u32 value)
proc  snd_emu1010_fpga_write  stdcall, reg:dword, value:dword

	push	ebx ecx edx
	;if (reg > 0x3f)
	;        return 1;
	mov	eax, [reg]
	cmp	eax, 0x3F
	jg	.err

	add	eax, 0x40 ;reg += 0x40; ;; 0x40 upwards are registers. ;;
	;if (value > 0x3f) ;; 0 to 0x3f are values ;;
	;        return 1;
	mov	ebx, [value]
	cmp	ebx, 0x3F
	jg	.err

	;outl(reg, emu->port + A_IOCFG);
	;udelay(10);
	;outl(reg | 0x80, emu->port + A_IOCFG);  ;; High bit clocks the value into the fpga. ;;
	;udelay(10);
	;outl(value, emu->port + A_IOCFG);
	;udelay(10);
	;outl(value | 0x80 , emu->port + A_IOCFG);  ;; High bit clocks the value into the fpga. ;;
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	mov	ecx, 10
	call	udelay

	or	eax, 0x80
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	mov	ecx, 10
	call	udelay

	mov	eax, ebx
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	mov	ecx, 10
	call	udelay

	or	eax, 0x80
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]

	;return 0;
	pop	edx ecx ebx
	xor	eax, eax
	ret
  .err:
	pop	edx ecx ebx
	xor	eax, eax
	inc	eax
	ret
endp


;int snd_emu1010_fpga_read(struct snd_emu10k1 * emu, u32 reg, u32 *value)
proc  snd_emu1010_fpga_read  stdcall, reg:dword;, value:dword    <- returned in eax

	push	ebx ecx edx
	;if (reg > 0x3f)
	;        return 1;
	mov	eax, [reg]
	cmp	eax, 0x3F
	jg	.err

	add	eax, 0x40 ;reg += 0x40; ;; 0x40 upwards are registers. ;;

	;outl(reg, emu->port + A_IOCFG);
	;udelay(10);
	;outl(reg | 0x80, emu->port + A_IOCFG);  ;; High bit clocks the value into the fpga. ;;
	;udelay(10);
	;*value = ((inl(emu->port + A_IOCFG) >> 8) & 0x7f);
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	mov	ecx, 10
	call	udelay

	or	eax, 0x80
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	mov	ecx, 10
	call	udelay

	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	shr	eax, 8
	and	eax, 0x7F

	pop	edx ecx ebx
	ret
  .err:
	pop	edx ecx ebx
	mov	eax, -1
	ret
endp


;; Each Destination has one and only one Source,
;; but one Source can feed any number of Destinations simultaneously.
;;
;int snd_emu1010_fpga_link_dst_src_write(struct snd_emu10k1 * emu, u32 dst, u32 src)
proc  snd_emu1010_fpga_link_dst_src_write  stdcall, dst:dword, src:dword
	push	eax ebx
	mov	ebx, [dst]
	mov	eax, ebx
	shr	eax, 8
	and	eax, 0x3F
	stdcall snd_emu1010_fpga_write, 0x00, eax ;((dst >> 8) & 0x3f) );
	mov	eax, ebx
	and	eax, 0x3F
	stdcall snd_emu1010_fpga_write, 0x01, eax ;(dst & 0x3f) );
	mov	ebx, [src]
	mov	eax, ebx
	shr	eax, 8
	and	eax, 0x3F
	stdcall snd_emu1010_fpga_write, 0x02, eax ;((src >> 8) & 0x3f) );
	mov	eax, ebx
	and	eax, 0x3F
	stdcall snd_emu1010_fpga_write, 0x03, eax ;(src & 0x3f) );
	;return 0;
	pop	ebx eax
	ret
endp


;void snd_emu10k1_intr_enable(struct snd_emu10k1 *emu, unsigned int intrenb)
proc  snd_emu10k1_intr_enable  stdcall, intrenb:dword
	push	eax edx
	mov	edx, INTE
	call	[ctrl.ctrl_read32]
	or	eax, [intrenb]
	mov	edx, INTE
	call	[ctrl.ctrl_write32]
	pop	edx eax
	ret
endp


;void snd_emu10k1_intr_disable(struct snd_emu10k1 *emu, unsigned int intrenb)
proc  snd_emu10k1_intr_disable	stdcall, intrenb:dword
	push	eax ebx edx
	mov	edx, INTE
	call	[ctrl.ctrl_read32]
	mov	ebx, [intrenb]
	xor	ebx, -1
	and	eax, ebx
	mov	edx, INTE
	call	[ctrl.ctrl_write32]
	pop	edx ebx eax
	ret
endp


;void snd_emu10k1_voice_intr_enable(struct snd_emu10k1 *emu, unsigned int voicenum)
proc  snd_emu10k1_voice_intr_enable  stdcall, voicenum:dword
	push	eax ecx edx
	mov	eax, CLIEL
	; voice interrupt
	mov	ecx, [voicenum]
	cmp	ecx, 32
	jl	@f
	sub	ecx, 32
	mov	eax, CLIEH
  @@:
	shl	eax, 16
	mov	edx, PTR
	call	[ctrl.ctrl_write32]

	mov	edx, DATA
	call	[ctrl.ctrl_read32]
	mov	edx, 1
	shl	edx, cl
	or	eax, edx

	mov	edx, DATA
	call	[ctrl.ctrl_write32]
	pop	edx ecx eax
	ret
endp


;void snd_emu10k1_voice_intr_disable(struct snd_emu10k1 *emu, unsigned int voicenum)
proc  snd_emu10k1_voice_intr_disable  stdcall, voicenum:dword
	push	eax ecx edx
	mov	eax, CLIEL
	; voice interrupt
	mov	ecx, [voicenum]
	cmp	ecx, 32
	jl	@f
	sub	ecx, 32
	mov	eax, CLIEH
  @@:
	shl	eax, 16
	mov	edx, PTR
	call	[ctrl.ctrl_write32]

	mov	edx, DATA
	call	[ctrl.ctrl_read32]
	mov	edx, 1
	shl	edx, cl ;ecx
	xor	edx, -1
	and	eax, edx

	mov	edx, DATA
	call	[ctrl.ctrl_write32]
	pop	edx ecx eax
	ret
endp


;void snd_emu10k1_voice_intr_ack(struct snd_emu10k1 *emu, unsigned int voicenum)
proc  snd_emu10k1_voice_intr_ack  stdcall, voicenum:dword
	push	eax ebx edx
	mov	eax, CLIPL
	; voice interrupt
	mov	ebx, [voicenum]
	cmp	ebx, 32
	jl	@f
	sub	ebx, 32
	mov	eax, CLIPH
  @@:
	shl	eax, 16
	mov	edx, PTR
	call	[ctrl.ctrl_write32]

	mov	eax, 1
	shl	eax, ebx

	mov	edx, DATA
	call	[ctrl.ctrl_write32]
	pop	edx ebx eax
	ret
endp


;void snd_emu10k1_voice_half_loop_intr_enable(struct snd_emu10k1 *emu, unsigned int voicenum)
proc  snd_emu10k1_voice_half_loop_intr_enable  stdcall, voicenum:dword
	push	eax ebx edx
	mov	eax, HLIEL
	; voice interrupt
	mov	ebx, [voicenum]
	cmp	ebx, 32
	jl	@f
	sub	ebx, 32
	mov	eax, HLIEH
  @@:
	shl	eax, 16
	mov	edx, PTR
	call	[ctrl.ctrl_write32]

	mov	edx, DATA
	call	[ctrl.ctrl_read32]
	mov	edx, 1
	shl	edx, ebx
	or	eax, edx

	mov	edx, DATA
	call	[ctrl.ctrl_write32]
	pop	edx ebx eax
	ret
endp


;void snd_emu10k1_voice_half_loop_intr_disable(struct snd_emu10k1 *emu, unsigned int voicenum)
proc  snd_emu10k1_voice_half_loop_intr_disable	stdcall, voicenum:dword
	push	eax ecx edx
	mov	eax, HLIEL
	; voice interrupt
	mov	ecx, [voicenum]
	cmp	ecx, 32
	jl	@f
	sub	ecx, 32
	mov	eax, HLIEH
  @@:
	shl	eax, 16
	mov	edx, PTR
	call	[ctrl.ctrl_write32]

	mov	edx, DATA
	call	[ctrl.ctrl_read32]
	mov	edx, 1
	shl	edx, cl ;ecx
	xor	edx, -1
	and	eax, edx

	mov	edx, DATA
	call	[ctrl.ctrl_write32]
	pop	edx ecx eax
	ret
endp


;void snd_emu10k1_voice_half_loop_intr_ack(struct snd_emu10k1 *emu, unsigned int voicenum)
proc  snd_emu10k1_voice_half_loop_intr_ack  stdcall, voicenum:dword
	push	eax ebx edx
	mov	eax, HLIPL
	; voice interrupt
	mov	ebx, [voicenum]
	cmp	ebx, 32
	jl	@f
	sub	ebx, 32
	mov	eax, HLIPH
  @@:
	shl	eax, 16
	mov	edx, PTR
	call	[ctrl.ctrl_write32]

	mov	eax, 1
	shl	eax, ebx

	mov	edx, DATA
	call	[ctrl.ctrl_write32]
	pop	edx ebx eax
	ret
endp


;void snd_emu10k1_voice_set_loop_stop(struct snd_emu10k1 *emu, unsigned int voicenum)
proc  snd_emu10k1_voice_set_loop_stop  stdcall, voicenum:dword
	push	eax ebx edx
	mov	eax, SOLEL
	; voice interrupt
	mov	ebx, [voicenum]
	cmp	ebx, 32
	jl	@f
	sub	ebx, 32
	mov	eax, SOLEH
  @@:
	shl	eax, 16
	mov	edx, PTR
	call	[ctrl.ctrl_write32]

	mov	edx, DATA
	call	[ctrl.ctrl_read32]
	mov	edx, 1
	shl	edx, ebx
	or	eax, edx

	mov	edx, DATA
	call	[ctrl.ctrl_write32]
	pop	edx ebx eax
	ret
endp


;void snd_emu10k1_voice_clear_loop_stop(struct snd_emu10k1 *emu, unsigned int voicenum)
proc  snd_emu10k1_voice_clear_loop_stop  stdcall, voicenum:dword
	push	eax ecx edx
	mov	eax, SOLEL
	; voice interrupt
	mov	ecx, [voicenum]
	cmp	ecx, 32
	jl	@f
	sub	ecx, 32
	mov	eax, SOLEH
  @@:
	shl	eax, 16
	mov	edx, PTR
	call	[ctrl.ctrl_write32]

	mov	edx, DATA
	call	[ctrl.ctrl_read32]
	mov	edx, 1
	shl	edx, cl
	xor	edx, -1
	and	eax, edx

	mov	edx, DATA
	call	[ctrl.ctrl_write32]
	pop	edx ecx eax
	ret
endp


;void snd_emu10k1_wait(struct snd_emu10k1 *emu, unsigned int wait)
proc  snd_emu10k1_wait	stdcall, wait:dword
	push	eax ebx ecx edx edi
	mov	edx, WC
	call	[ctrl.ctrl_read32]
	shr	eax, 6

	mov	ecx, [wait]
  .wait:
	cmp	ecx, 0
	jng	.out
	mov	ebx, eax
	xor	edi, edi
  @@:
	mov	edx, WC
	call	[ctrl.ctrl_read32]
	shr	eax, 6

	cmp	eax, ebx
	jne	.wait

	inc	edi
	cmp	edi, 16384
	jl	@b
	;- jg     .out
	jmp	.wait
  .out:
	pop	edi edx ecx ebx eax
	ret
endp


;unsigned short snd_emu10k1_ac97_read(struct snd_ac97 *ac97, unsigned short reg)
proc snd_emu10k1_ac97_read  stdcall, reg:dword
	push	edx
	mov	eax, [reg]
	mov	edx, AC97ADDRESS
	call	[ctrl.ctrl_write8]
	mov	edx, AC97DATA
	call	[ctrl.ctrl_read16]
	and	eax, 0xFFFF
	pop	edx
	ret
endp

;void snd_emu10k1_ac97_write(struct snd_ac97 *ac97, unsigned short reg, unsigned short data)
proc snd_emu10k1_ac97_write  stdcall, reg:dword, data:dword
	push	eax edx
	mov	eax, [reg]
	mov	edx, AC97ADDRESS
	call	[ctrl.ctrl_write8]
	mov	eax, [data]
	mov	edx, AC97DATA
	call	[ctrl.ctrl_write16]
	pop	edx eax
	ret
endp


;  convert rate to pitch
;unsigned int snd_emu10k1_rate_to_pitch(unsigned int rate)
proc snd_emu10k1_rate_to_pitch	stdcall, rate:dword
	push	ebx ecx edx edi
	mov	eax, [rate]
	test	eax, eax
	jz	.out	; Bail out if no leading "1"

	mov	cx, 11185
	mul	cx     ; Scale 48000 to 0x20002380
	mov	ebx, eax
	mov	ecx, 31
  .next_one:
	test	ebx, 0x80000000
	jz	@f

	mov	edx, ecx
	sub	edx, 15
	shl	edx, 20

	mov	edi, logMagTable
	mov	eax, ebx
	shr	eax, 24
	and	eax, 0x7F
	push	eax
	shl	eax, 2
	add	edi, eax
	lodsd
	add	edx, eax
	pop	eax

	mov	edi, logSlopeTable
	add	edi, eax
	lodsd

	mov	ecx, ebx
	shr	ecx, 17
	and	ecx, 0x7F
	push	edx
	mul	ecx
	pop	edx
	add	eax, edx
	pop	edi edx ecx ebx
	ret
  @@:
	shr	ebx, 1
	loop	.next_one
  .out:
	pop	edi edx ecx ebx
	xor	eax, eax
	ret
endp


;Data

logMagTable: ;[128]
	dd   0x00000, 0x02dfc, 0x05b9e, 0x088e6, 0x0b5d6, 0x0e26f, 0x10eb3, 0x13aa2
	dd   0x1663f, 0x1918a, 0x1bc84, 0x1e72e, 0x2118b, 0x23b9a, 0x2655d, 0x28ed5
	dd   0x2b803, 0x2e0e8, 0x30985, 0x331db, 0x359eb, 0x381b6, 0x3a93d, 0x3d081
	dd   0x3f782, 0x41e42, 0x444c1, 0x46b01, 0x49101, 0x4b6c4, 0x4dc49, 0x50191
	dd   0x5269e, 0x54b6f, 0x57006, 0x59463, 0x5b888, 0x5dc74, 0x60029, 0x623a7
	dd   0x646ee, 0x66a00, 0x68cdd, 0x6af86, 0x6d1fa, 0x6f43c, 0x7164b, 0x73829
	dd   0x759d4, 0x77b4f, 0x79c9a, 0x7bdb5, 0x7dea1, 0x7ff5e, 0x81fed, 0x8404e
	dd   0x86082, 0x88089, 0x8a064, 0x8c014, 0x8df98, 0x8fef1, 0x91e20, 0x93d26
	dd   0x95c01, 0x97ab4, 0x9993e, 0x9b79f, 0x9d5d9, 0x9f3ec, 0xa11d8, 0xa2f9d
	dd   0xa4d3c, 0xa6ab5, 0xa8808, 0xaa537, 0xac241, 0xadf26, 0xafbe7, 0xb1885
	dd   0xb3500, 0xb5157, 0xb6d8c, 0xb899f, 0xba58f, 0xbc15e, 0xbdd0c, 0xbf899
	dd   0xc1404, 0xc2f50, 0xc4a7b, 0xc6587, 0xc8073, 0xc9b3f, 0xcb5ed, 0xcd07c
	dd   0xceaec, 0xd053f, 0xd1f73, 0xd398a, 0xd5384, 0xd6d60, 0xd8720, 0xda0c3
	dd   0xdba4a, 0xdd3b4, 0xded03, 0xe0636, 0xe1f4e, 0xe384a, 0xe512c, 0xe69f3
	dd   0xe829f, 0xe9b31, 0xeb3a9, 0xecc08, 0xee44c, 0xefc78, 0xf148a, 0xf2c83
	dd   0xf4463, 0xf5c2a, 0xf73da, 0xf8b71, 0xfa2f0, 0xfba57, 0xfd1a7, 0xfe8df

logSlopeTable: ;[128]
	db   0x5c, 0x5c, 0x5b, 0x5a, 0x5a, 0x59, 0x58, 0x58
	db   0x57, 0x56, 0x56, 0x55, 0x55, 0x54, 0x53, 0x53
	db   0x52, 0x52, 0x51, 0x51, 0x50, 0x50, 0x4f, 0x4f
	db   0x4e, 0x4d, 0x4d, 0x4d, 0x4c, 0x4c, 0x4b, 0x4b
	db   0x4a, 0x4a, 0x49, 0x49, 0x48, 0x48, 0x47, 0x47
	db   0x47, 0x46, 0x46, 0x45, 0x45, 0x45, 0x44, 0x44
	db   0x43, 0x43, 0x43, 0x42, 0x42, 0x42, 0x41, 0x41
	db   0x41, 0x40, 0x40, 0x40, 0x3f, 0x3f, 0x3f, 0x3e
	db   0x3e, 0x3e, 0x3d, 0x3d, 0x3d, 0x3c, 0x3c, 0x3c
	db   0x3b, 0x3b, 0x3b, 0x3b, 0x3a, 0x3a, 0x3a, 0x39
	db   0x39, 0x39, 0x39, 0x38, 0x38, 0x38, 0x38, 0x37
	db   0x37, 0x37, 0x37, 0x36, 0x36, 0x36, 0x36, 0x35
	db   0x35, 0x35, 0x35, 0x34, 0x34, 0x34, 0x34, 0x34
	db   0x33, 0x33, 0x33, 0x33, 0x32, 0x32, 0x32, 0x32
	db   0x32, 0x31, 0x31, 0x31, 0x31, 0x31, 0x30, 0x30
	db   0x30, 0x30, 0x30, 0x2f, 0x2f, 0x2f, 0x2f, 0x2f

