
;  Init to 0x02109204 :
 ;  Clock accuracy    = 0     (1000ppm)
 ;  Sample Rate       = 2     (48kHz)
 ;  Audio Channel     = 1     (Left of 2)
 ;  Source Number     = 0     (Unspecified)
 ;  Generation Status = 1     (Original for Cat Code 12)
 ;  Cat Code          = 12    (Digital Signal Mixer)
 ;  Mode              = 0     (Mode 0)
 ;  Emphasis          = 0     (None)
 ;  CP                = 1     (Copyright unasserted)
 ;  AN                = 0     (Audio data)
 ;  P                 = 0     (Consumer)

SPDIF_BITS_0  equ  SPCS_CLKACCY_1000PPM or SPCS_SAMPLERATE_48 \
		     or SPCS_CHANNELNUM_LEFT or SPCS_SOURCENUM_UNSPEC \
		     or SPCS_GENERATIONSTATUS or 0x00001200 or 0x00000000 \
		     or SPCS_EMPHASIS_NONE or SPCS_COPYRIGHT
SPDIF_BITS_1  equ  SPDIF_BITS_0
SPDIF_BITS_2  equ  SPDIF_BITS_0


; EMU10K1 init/done

align 4
proc snd_emu10k1_voice_init  stdcall, chn:dword
	stdcall snd_emu10k1_ptr_write, DCYSUSV, [chn], 0
	stdcall snd_emu10k1_ptr_write, IP,	[chn], 0
	stdcall snd_emu10k1_ptr_write, VTFT,	[chn], 0xFFFF
	stdcall snd_emu10k1_ptr_write, CVCF,	[chn], 0xFFFF
	stdcall snd_emu10k1_ptr_write, PTRX,	[chn], 0
	stdcall snd_emu10k1_ptr_write, CPF,	[chn], 0
	stdcall snd_emu10k1_ptr_write, CCR,	[chn], 0

	stdcall snd_emu10k1_ptr_write, PSST,	[chn], 0
	stdcall snd_emu10k1_ptr_write, DSL,	[chn], 0x10
	stdcall snd_emu10k1_ptr_write, CCCA,	[chn], 0
	stdcall snd_emu10k1_ptr_write, Z1,	[chn], 0
	stdcall snd_emu10k1_ptr_write, Z2,	[chn], 0
	stdcall snd_emu10k1_ptr_write, FXRT,	[chn], 0x32100000

	stdcall snd_emu10k1_ptr_write, ATKHLDM, [chn], 0
	stdcall snd_emu10k1_ptr_write, DCYSUSM, [chn], 0
	stdcall snd_emu10k1_ptr_write, IFATN,	[chn], 0xFFFF
	stdcall snd_emu10k1_ptr_write, PEFE,	[chn], 0
	stdcall snd_emu10k1_ptr_write, FMMOD,	[chn], 0
	stdcall snd_emu10k1_ptr_write, TREMFRQ, [chn], 24  ; 1Hz
	stdcall snd_emu10k1_ptr_write, FM2FRQ2, [chn], 24  ; 1Hz
	stdcall snd_emu10k1_ptr_write, TEMPENV, [chn], 0

	; these are last so OFF prevents writing
	stdcall snd_emu10k1_ptr_write, LFOVAL2, [chn], 0
	stdcall snd_emu10k1_ptr_write, LFOVAL1, [chn], 0
	stdcall snd_emu10k1_ptr_write, ATKHLDV, [chn], 0
	stdcall snd_emu10k1_ptr_write, ENVVOL,	[chn], 0
	stdcall snd_emu10k1_ptr_write, ENVVAL,	[chn], 0

	; Audigy extra stuffs
	test	[ctrl.chip_type], AUDIGY_CHIP
	jz	.not_audigy

	stdcall snd_emu10k1_ptr_write, 0x4C,	[chn], 0
	stdcall snd_emu10k1_ptr_write, 0x4D,	[chn], 0
	stdcall snd_emu10k1_ptr_write, 0x4E,	[chn], 0
	stdcall snd_emu10k1_ptr_write, 0x4F,	[chn], 0
	stdcall snd_emu10k1_ptr_write, A_FXRT1, [chn], 0x03020100
	stdcall snd_emu10k1_ptr_write, A_FXRT2, [chn], 0x3f3f3f3f
	stdcall snd_emu10k1_ptr_write, A_SENDAMOUNTS, [chn], 0
  .not_audigy:
	ret
endp


align 4
proc snd_emu10k1_init  stdcall, enable_ir:dword, resume:dword
	pusha
	; disable audio and lock cache
	mov	eax, HCFG_LOCKSOUNDCACHE or HCFG_LOCKTANKCACHE_MASK or HCFG_MUTEBUTTONENABLE
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	; reset recording buffers
	stdcall snd_emu10k1_ptr_write, MICBS, 0, ADCBS_BUFSIZE_NONE
	stdcall snd_emu10k1_ptr_write, MICBA, 0, 0
	stdcall snd_emu10k1_ptr_write, FXBS,  0, ADCBS_BUFSIZE_NONE
	stdcall snd_emu10k1_ptr_write, FXBA,  0, 0
	stdcall snd_emu10k1_ptr_write, ADCBS, 0, ADCBS_BUFSIZE_NONE
	stdcall snd_emu10k1_ptr_write, ADCBA, 0, 0
	; disable channel interrupt
	xor	eax, eax
	mov	edx, INTE
	call	[ctrl.ctrl_write32]

	stdcall snd_emu10k1_ptr_write, CLIEL, 0, 0
	stdcall snd_emu10k1_ptr_write, CLIEH, 0, 0
	stdcall snd_emu10k1_ptr_write, SOLEL, 0, 0
	stdcall snd_emu10k1_ptr_write, SOLEH, 0, 0

	test	[ctrl.chip_type], AUDIGY_CHIP
	jz	@f
	; set SPDIF bypass mode
	stdcall snd_emu10k1_ptr_write, SPBYPASS, 0, SPBYPASS_FORMAT
	; enable rear left + rear right AC97 slots
	stdcall snd_emu10k1_ptr_write, AC97SLOT, 0, AC97SLOT_REAR_RIGHT or AC97SLOT_REAR_LEFT
  @@:
	; init envelope engine
	xor	ecx, ecx
  .init_ee:
	stdcall snd_emu10k1_voice_init, ecx
	inc	ecx
	cmp	ecx, NUM_G
	jl	.init_ee

	stdcall snd_emu10k1_ptr_write, SPCS0, 0, SPDIF_BITS_0
	stdcall snd_emu10k1_ptr_write, SPCS1, 0, SPDIF_BITS_1
	stdcall snd_emu10k1_ptr_write, SPCS2, 0, SPDIF_BITS_2

	test	[ctrl.chip_type], CA0151_CHIP
	jz	.not_ca0151
	; audigy2
	; Hacks for Alice3 to work independent of haP16V driver
	; Setup SRCMulti_I2S SamplingRate
	stdcall snd_emu10k1_ptr_read, A_SPDIF_SAMPLERATE, 0
	and	eax, 0xFFFFF1FF
	or	eax, 0x2 shl 9
	stdcall snd_emu10k1_ptr_write, A_SPDIF_SAMPLERATE, 0, eax

	; Setup SRCSel (Enable Spdif,I2S SRCMulti)
	stdcall snd_emu10k1_ptr20_write, SRCSel, 0, 0x14
	; Setup SRCMulti Input Audio Enable
	; Use 0xFFFFFFFF to enable P16V sounds.
	stdcall snd_emu10k1_ptr20_write, SRCMULTI_ENABLE, 0, 0xFFFFFFFF
	; Enabled Phased (8-channel) P16V playback
	mov	eax, 0x0201
	mov	edx, HCFG2
	call	[ctrl.ctrl_write32]

	;Set playback routing
	stdcall snd_emu10k1_ptr20_write, CAPTURE_P16V_SOURCE, 0, 0x78E4
  .not_ca0151:

	test	[ctrl.chip_type], CA0108_CHIP
	jz	.not_ca0108
	; audigy2
	; Hacks for Alice3 to work independent of haP16V driver
	mov	esi, msgAudigy2SpecConf
	call	SysMsgBoardStr

	; Setup SRCMulti_I2S SamplingRate
	stdcall snd_emu10k1_ptr_read, A_SPDIF_SAMPLERATE, 0
	and	eax, 0xFFFFF1FF
	or	eax, 0x2 shl 9
	stdcall snd_emu10k1_ptr_write, A_SPDIF_SAMPLERATE, 0, eax

	; Setup SRCSel (Enable Spdif,I2S SRCMulti)
	mov	eax, 0x600000
	mov	edx, 0x20
	call	[ctrl.ctrl_write32]
	mov	eax, 0x14
	mov	edx, 0x24
	call	[ctrl.ctrl_write32]
	; Setup SRCMulti Input Audio Enable
	mov	eax, 0x7B0000
	mov	edx, 0x20
	call	[ctrl.ctrl_write32]
	mov	eax, 0xFF000000
	mov	edx, 0x24
	call	[ctrl.ctrl_write32]
	; Setup SPDIF Out Audio Enable
	; The Audigy 2 Value has a separate SPDIF out,
	; so no need for a mixer switch
	mov	eax, 0x7A0000
	mov	edx, 0x20
	call	[ctrl.ctrl_write32]
	mov	eax, 0xFF000000
	mov	edx, 0x24
	call	[ctrl.ctrl_write32]

	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	and	eax, 0xFFFFFFFB   ; Clear bit 3
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
  .not_ca0108:

	test	[ctrl.chip_type], SPI_DAC_CHIP
	jz	.not_spi_dac
	; Audigy2 ZS Notebook with DAC Wolfson WM8768/WM8568
	xor	ecx, ecx
	mov	ebx, spi_dac_init_end - spi_dac_init ; size of array
  @@:
	stdcall snd_emu10k1_spi_write, [spi_dac_init+ecx]
	inc	ecx
	cmp	ecx, ebx
	jl	@b

	stdcall snd_emu10k1_ptr20_write, 0x60, 0, 0x10
	; Enable GPIOs
	; GPI00: Unknown
	; GPI01: Speakers-enabled.
	; GPI02: Unknown
	; GPI03: Unknown
	; GPI04: IEC958 Output on.
	; GPI05: Unknown
	; GPI06: Unknown
	; GPI07: Unknown
	mov	eax, 0x76   ; Windows uses 0x3F76
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
  .not_spi_dac:

	test	[ctrl.chip_type], I2C_ADC_CHIP
	jz	.not_i2c_adc
	; Audigy2 ZS Notebook with ADC Wolfson WM8775
	stdcall snd_emu10k1_ptr20_write, P17V_I2S_SRC_SEL, 0, 0x2020205F
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	or	eax, 0x4    ; Set bit 2 for mic input
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]

	xor	ecx, ecx
	mov	ebx, i2c_adc_init_end - i2c_adc_init ; size of array
  @@:
	stdcall snd_emu10k1_i2c_write, [i2c_adc_init+ecx], [i2c_adc_init+ecx+1]
	add	ecx, 2
	cmp	ecx, ebx
	jl	@b
    if 0  ; Infinity doesn't support capture for the current moment
	mov	ecx, 4+4
	mov	edi, i2c_capture_volume
	mov	eax, 0xCF
	repne	stosd
    end if
  .not_i2c_adc:

;R        mov     eax, [emu.ptb_pages_addr]
;R        stdcall snd_emu10k1_ptr_write, PTB,  0, eax
;R        stdcall snd_emu10k1_ptr_write, TCB,  0, 0
;R        stdcall snd_emu10k1_ptr_write, TCBS, 0, 4     ; taken from original driver

;R        shl     eax, 1
;R        or      eax, MAP_PTI_MASK     ; eax = silent_page
;R        xor     ecx, ecx
;R  @@:
;R        stdcall snd_emu10k1_ptr_write, MAPA, ecx, eax
;R        stdcall snd_emu10k1_ptr_write, MAPB, ecx, eax
;R        inc     ecx
;R        cmp     ecx, NUM_G
;R        jl      @b

	test	[ctrl.chip_type], EMU_MODEL_CHIP
	jz	.not_emu_model

	mov	eax, HCFG_AUTOMUTE_ASYNC or HCFG_EMU32_SLAVE or HCFG_AUDIOENABLE
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	;
	;  Hokay, setup HCFG
	;   Mute Disable Audio = 0
	;   Lock Tank Memory = 1
	;   Lock Sound Memory = 0
	;   Auto Mute = 1
	jmp	.HCFG_setup_done
  .not_emu_model:

	test	[ctrl.chip_type], AUDIGY_CHIP
	jz	.not_audigy

	cmp	[ctrl.revision], 4  ;audigy2
	jne	@f

	mov	eax, HCFG_AUDIOENABLE or HCFG_AC3ENABLE_CDSPDIF or HCFG_AC3ENABLE_GPSPDIF \
			or HCFG_AUTOMUTE or HCFG_JOYENABLE
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	jmp	.HCFG_setup_done
  @@:
	mov	eax, HCFG_AUTOMUTE or HCFG_JOYENABLE
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	jmp	.HCFG_setup_done
  .not_audigy:

	; FIXME: Remove all these emu->model and replace it with a card recognition parameter,
	; e.g. card_capabilities->joystick
if 0 ;Asper [ Temporary cut off this code
	cmp	[ctrl.model], 0x20
	je	@f
	cmp	[ctrl.model], 0xC400
	je	@f
	cmp	[ctrl.model], 0x21
	jne	.another_chip
	cmp	[ctrl.revision], 6
	jne	.another_chip
  @@:
	mov	eax, HCFG_LOCKTANKCACHE_MASK or HCFG_AUTOMUTE
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	jmp	.HCFG_setup_done
end if ;Asper ] Temporary cut off this code

  .another_chip:
	; With on-chip joystick
	mov	eax, HCFG_LOCKTANKCACHE_MASK or HCFG_AUTOMUTE or HCFG_JOYENABLE
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
  .HCFG_setup_done:

	mov	eax, [enable_ir]   ; enable IR for SB Live
	or	eax, eax
	jz	.end_enable_ir

	test	[ctrl.chip_type], EMU_MODEL_CHIP
	jz	@f
	; Disable all access to A_IOCFG for the emu1010
	jmp	.end_enable_ir
  @@:
	test	[ctrl.chip_type], I2C_ADC_CHIP
	jz	@f
	; Disable A_IOCFG for Audigy 2 ZS Notebook
	jmp	.end_enable_ir
  @@:
	test	[ctrl.chip_type], AUDIGY_CHIP
	jz	@f

	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	mov	ebx, eax
	or	eax, A_IOCFG_GPOUT2
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	mov	eax, 500000   ; udelay(500);
	call	StallExec
	mov	eax, ebx
	or	eax, A_IOCFG_GPOUT1 or A_IOCFG_GPOUT2
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	mov	eax, 100000   ; udelay(100);
	call	StallExec
	mov	eax, ebx
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	jmp	.end_enable_ir
  @@:
	mov	edx, HCFG
	call	[ctrl.ctrl_read32]
	mov	ebx, eax
	or	eax, HCFG_GPOUT2
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	mov	eax, 500000   ; udelay(500);
	call	StallExec
	mov	eax, ebx
	or	eax, HCFG_GPOUT1 or HCFG_GPOUT2
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	mov	eax, 100000   ; udelay(100);
	call	StallExec
	mov	eax, ebx
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
  .end_enable_ir:

	test	[ctrl.chip_type], EMU_MODEL_CHIP
	jz	@f
	; Disable all access to A_IOCFG for the emu1010
	jmp	.all_done
  @@:
	test	[ctrl.chip_type], I2C_ADC_CHIP
	jz	@f
	; Disable A_IOCFG for Audigy 2 ZS Notebook
	jmp	.all_done
  @@:
	test	[ctrl.chip_type], AUDIGY_CHIP
	jz	@f
	; enable analog output
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	or	eax, A_IOCFG_GPOUT0
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
  @@:
  .all_done:
	popa
	ret
endp


align 4
proc snd_emu10k1_audio_enable
	push	eax ebx edx
	; Enable the audio bit
	mov	edx, HCFG
	call	[ctrl.ctrl_read32]
	or	eax, HCFG_AUDIOENABLE
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]

	; Enable analog/digital outs on audigy
	test	[ctrl.chip_type], EMU_MODEL_CHIP
	jz	@f
	; Disable all access to A_IOCFG for the emu1010
	jmp	.end_enable_outs
  @@:
	test	[ctrl.chip_type], I2C_ADC_CHIP
	jz	@f
	; Disable A_IOCFG for Audigy 2 ZS Notebook
	jmp	.end_enable_outs
  @@:
	test	[ctrl.chip_type], AUDIGY_CHIP
	jz	.end_enable_outs

	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	and	eax, 0xFFFFFFBB  ;~0x44
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
  @@:
	test	[ctrl.chip_type], CA0151_CHIP  ; audigy2
	jz	@f
	; Unmute Analog now.  Set GPO6 to 1 for Apollo.
	; This has to be done after init ALice3 I2SOut beyond 48KHz.
	; So, sequence is important.
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	or	eax, 0x0040
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	jmp	.end_enable_outs
  @@:
	test	[ctrl.chip_type], CA0151_CHIP  ; audigy2 value
	jz	@f
	; Unmute Analog now.
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	or	eax, 0x0060
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
	jmp	.end_enable_outs
  @@:
	; Disable routing from AC97 line out to Front speakers
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_read32]
	or	eax, 0x0080
	mov	edx, A_IOCFG
	call	[ctrl.ctrl_write32]
  .end_enable_outs:
    if 0
	; FIXME: the following routine disables LiveDrive-II !!
	; TOSLink detection
	mov	[emu.tos_link], 0
	mov	edx, HCFG
	call	[ctrl.ctrl_read32]
	test	eax, HCFG_GPINPUT0 or HCFG_GPINPUT1
	jz	@f

	mov	ebx, eax
	or	eax, 0x800
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	mov	eax, 50000   ; udelay(50);
	call	StallExec

	mov	edx, HCFG
	call	[ctrl.ctrl_read32]
	and	eax, 0xFFFFF7FF  ;~0x800
	cmp	eax, ebx
	je	@f

	mov	[emu.tos_link], 1
	mov	eax, ebx
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
  @@:
    end if
	stdcall snd_emu10k1_intr_enable, INTE_PCIERRORENABLE
	pop	edx ebx eax
	ret
endp


align 4
proc snd_emu10k1_done
	push	eax ecx edx
	mov	edx, INTE
	xor	eax, eax
	call	[ctrl.ctrl_write32]

	; Shutdown the chip
	xor	ecx, ecx
  @@:
	stdcall snd_emu10k1_ptr_write, DCYSUSV, ecx, 0
	inc	ecx
	cmp	ecx, NUM_G
	jl	@b

	xor	ecx, ecx
  @@:
	stdcall snd_emu10k1_ptr_write, VTFT,	ecx, 0xFFFF
	stdcall snd_emu10k1_ptr_write, CVCF,	ecx, 0xFFFF
	stdcall snd_emu10k1_ptr_write, PTRX,	ecx, 0
	stdcall snd_emu10k1_ptr_write, CPF,	ecx, 0
	inc	ecx
	cmp	ecx, NUM_G
	jl	@b

	;reset recording buffers
	stdcall snd_emu10k1_ptr_write, MICBS,	0, 0
	stdcall snd_emu10k1_ptr_write, MICBA,	0, 0
	stdcall snd_emu10k1_ptr_write, FXBS,	0, 0
	stdcall snd_emu10k1_ptr_write, FXWC,	0, 0

	stdcall snd_emu10k1_ptr_write, ADCBS,	0, ADCBS_BUFFSIZE_NONE
	stdcall snd_emu10k1_ptr_write, ADCBA,	0, 0
	stdcall snd_emu10k1_ptr_write, TCBS,	0, TCBS_BUFFSIZE_16K
	stdcall snd_emu10k1_ptr_write, TCB,	0, 0

	test	[chip_type], AUDIGY_CHIP
	jz	@f

	stdcall snd_emu10k1_ptr_write, A_DBG,	0, A_DBG_SINGLE_STEP
	jmp	.DBG_done
  @@:
	stdcall snd_emu10k1_ptr_write, DBG,	0, EMU10K1_DBG_SINGLE_STEP
  .DBG_done:

	; disable channel interrupts
	stdcall snd_emu10k1_ptr_write, CLIEL, 0, 0
	stdcall snd_emu10k1_ptr_write, CLIEH, 0, 0
	stdcall snd_emu10k1_ptr_write, SOLEL, 0, 0
	stdcall snd_emu10k1_ptr_write, SOLEH, 0, 0

	; disable audio and lock sound cache
	mov	eax, HCFG_LOCKSOUNDCACHE or HCFG_LOCKTANKCACHE_MASK or HCFG_MUTEBUTTONENABLE
	mov	edx, HCFG
	call	[ctrl.ctrl_write32]
	stdcall snd_emu10k1_ptr_write, PTB,   0, 0
	pop	edx ecx eax
	ret
endp

; (...)
; Some functions not implemented, some have to be implemented to support Audigy etc chips.


proc snd_emu10k1_create  stdcall, enable_ir:dword     ;, subsystem:dword,

;-        is_audigy = emu->audigy = c->emu10k2_chip;

	; set the DMA transfer mask
;No need?        emu->dma_mask = is_audigy ? AUDIGY_DMA_MASK : EMU10K1_DMA_MASK;
;No need?        if (pci_set_dma_mask(pci, emu->dma_mask) < 0 ||
;No need?            pci_set_consistent_dma_mask(pci, emu->dma_mask) < 0) {
;No need?                snd_printk(KERN_ERR "architecture does not support PCI busmaster DMA with mask 0x%lx\n", emu->dma_mask);
;No need?                kfree(emu);
;No need?                pci_disable_device(pci);
;No need?                return -ENXIO;
;No need?        }
;No need?        mov     [emu.dma_mask], AUDIGY_DMA_MASK
;No need?        test    [chip_type], AUDIGY_CHIP
;No need?        jz      @f
;No need?        mov     [emu.dma_mask], EMU10K1_DMA_MASK
;No need?  @@:

	mov	[ctrl.gpr_base], FXGPREGBASE
	test	[ctrl.chip_type], AUDIGY_CHIP
	jz	@f
	mov	[ctrl.gpr_base], A_FXGPREGBASE
  @@:

;R        emu->port = pci_resource_start(pci, 0);

;R        emu->max_cache_pages = max_cache_bytes >> PAGE_SHIFT;
;R        if (snd_dma_alloc_pages(SNDRV_DMA_TYPE_DEV, snd_dma_pci_data(pci),
;R                                32 * 1024, &emu->ptb_pages) < 0) {
;R                err = -ENOMEM;
;R                goto error;
;R        }

;-        emu->page_ptr_table = vmalloc(emu->max_cache_pages * sizeof(void *));
;-        emu->page_addr_table = vmalloc(emu->max_cache_pages *
;-                                       sizeof(unsigned long));
;-        if (emu->page_ptr_table == NULL || emu->page_addr_table == NULL) {
;-                err = -ENOMEM;
;-                goto error;
;-        }

;-        if (snd_dma_alloc_pages(SNDRV_DMA_TYPE_DEV, snd_dma_pci_data(pci),
;-                                EMUPAGESIZE, &emu->silent_page) < 0) {
;-                err = -ENOMEM;
;-                goto error;
;-        }

	;pci_set_master(pci);
	stdcall PciRead16,  [ctrl.bus], [ctrl.devfn], dword 4
	test	eax, 4	; test master bit
	jnz	@f
	or	eax, 4
	stdcall PciWrite16, [ctrl.bus], [ctrl.devfn], dword 4, eax  ; set master bit
  @@:

;Future?        emu->fx8010.fxbus_mask = 0x303f;
;Future?        if (extin_mask == 0)
;Future?                extin_mask = 0x3fcf;
;Future?        if (extout_mask == 0)
;Future?                extout_mask = 0x7fff;
;Future?        emu->fx8010.extin_mask = extin_mask;
;Future?        emu->fx8010.extout_mask = extout_mask;
;Future?        emu->enable_ir = enable_ir;

;Future?        if (emu->card_capabilities->ca_cardbus_chip) {
;Future?                err = snd_emu10k1_cardbus_init(emu);
;Future?                if (err < 0) goto error;
;Future?        }
;Future?        if (emu->card_capabilities->ecard) {
;Future?                err = snd_emu10k1_ecard_init(emu);
;Future?                if (err < 0) goto error;
;Future?        } else if (emu->card_capabilities->emu_model) {
;Future?                err = snd_emu10k1_emu1010_init(emu);
;Future?                if (err < 0) {
;Future?                        snd_emu10k1_free(emu);
;Future?                        return err;
;Future?                }
;Future?        } else {
		; 5.1: Enable the additional AC97 Slots. If the emu10k1 version
		;        does not support this, it shouldn't do any harm
		stdcall snd_emu10k1_ptr_write, AC97SLOT, 0, AC97SLOT_CNTR or AC97SLOT_LFE
;Future?        }

;Future?        /* initialize TRAM setup */
;Future?        emu->fx8010.itram_size = (16 * 1024)/2;
;Future?        emu->fx8010.etram_pages.area = NULL;
;Future?        emu->fx8010.etram_pages.bytes = 0;

	; irq handler must be registered after I/O ports are activated
;R        if (request_irq(pci->irq, snd_emu10k1_interrupt, IRQF_SHARED,
;R                        "EMU10K1", emu)) {
;R                err = -EBUSY;
;R                goto error;
;R        }
;R        emu->irq = pci->irq;


	 ;  Init to 0x02109204 :
	 ;  Clock accuracy    = 0     (1000ppm)
	 ;  Sample Rate       = 2     (48kHz)
	 ;  Audio Channel     = 1     (Left of 2)
	 ;  Source Number     = 0     (Unspecified)
	 ;  Generation Status = 1     (Original for Cat Code 12)
	 ;  Cat Code          = 12    (Digital Signal Mixer)
	 ;  Mode              = 0     (Mode 0)
	 ;  Emphasis          = 0     (None)
	 ;  CP                = 1     (Copyright unasserted)
	 ;  AN                = 0     (Audio data)
	 ;  P                 = 0     (Consumer)


;No need?        emu->reserved_page = (struct snd_emu10k1_memblk *)
;No need?                snd_emu10k1_synth_alloc(emu, 4096);
;No need?        if (emu->reserved_page)
;No need?                emu->reserved_page->map_locked = 1;

;R        ; Clear silent pages and set up pointers
;R        memset(emu->silent_page.area, 0, PAGE_SIZE);
;R        silent_page = emu->silent_page.addr << 1;
;R        for (idx = 0; idx < MAXPAGES; idx++)
;R                ((u32 *)emu->ptb_pages.area)[idx] = cpu_to_le32(silent_page | idx);

;R        ; set up voice indices
;R        for (idx = 0; idx < NUM_G; idx++) {
;R                emu->voices[idx].emu = emu;
;R                emu->voices[idx].number = idx;
;R        }

	stdcall snd_emu10k1_init, [enable_ir], 0

;Future?        ;  Initialize the effect engine
;Future?        err = snd_emu10k1_init_efx(emu);
;Future?        if (err < 0)
;Future?                goto error;
	stdcall snd_emu10k1_audio_enable



	xor	eax, eax
	ret

 .error:
;-        stdcall snd_emu10k1_free
	ret
endp




;DATA

spi_dac_init:
	    dd	0x00ff, 0x02ff, 0x0400, 0x0520, 0x0600, 0x08ff, 0x0aff
	    dd	0x0cff, 0x0eff, 0x10ff, 0x1200, 0x1400, 0x1480, 0x1800
	    dd	0x1aff, 0x1cff, 0x1e00, 0x0530, 0x0602, 0x0622, 0x1400
spi_dac_init_end:

i2c_adc_init: ;[][2]
	    dd	0x17, 0x00  ; Reset
	    dd	0x07, 0x00  ; Timeout
	    dd	0x0b, 0x22   ; Interface control
	    dd	0x0c, 0x22   ; Master mode control
	    dd	0x0d, 0x08   ; Powerdown control
	    dd	0x0e, 0xcf   ; Attenuation Left  0x01 = -103dB, 0xff = 24dB
	    dd	0x0f, 0xcf   ; Attenuation Right 0.5dB steps
	    dd	0x10, 0x7b   ; ALC Control 1
	    dd	0x11, 0x00   ; ALC Control 2
	    dd	0x12, 0x32   ; ALC Control 3
	    dd	0x13, 0x00   ; Noise gate control
	    dd	0x14, 0xa6   ; Limiter control
	    dd	0x15, ADC_MUX_2   ; ADC Mixer control. Mic for A2ZS Notebook
i2c_adc_init_end:
